diff --git a/fftools/ffmpeg_opt.c b/fftools/ffmpeg_opt.c
index bdb71d4283..6ff1cb229d 100644
--- a/fftools/ffmpeg_opt.c
+++ b/fftools/ffmpeg_opt.c
@@ -1476,7 +1476,7 @@ const OptionDef options[] = {
     CMDUTILS_COMMON_OPTIONS
     { "f",                      OPT_TYPE_STRING, OPT_OFFSET | OPT_INPUT | OPT_OUTPUT,
         { .off       = OFFSET(format) },
-        "force format", "fmt" },
+        "force container format (auto-detected otherwise)", "fmt" },
     { "y",                      OPT_TYPE_BOOL, 0,
         {              &file_overwrite },
         "overwrite output files" },
@@ -1494,11 +1494,11 @@ const OptionDef options[] = {
         "allow recasting stream type in order to force a decoder of different media type" },
     { "c",                      OPT_TYPE_STRING, OPT_PERSTREAM | OPT_INPUT | OPT_OUTPUT | OPT_HAS_CANON,
         { .off       = OFFSET(codec_names) },
-        "codec name", "codec",
+        "select encoder/decoder ('copy' to copy stream without reencoding)", "codec",
         .u1.name_canon = "codec", },
     { "codec",                  OPT_TYPE_STRING, OPT_PERSTREAM | OPT_INPUT | OPT_OUTPUT | OPT_EXPERT | OPT_HAS_ALT,
         { .off       = OFFSET(codec_names) },
-        "codec name", "codec",
+        "alias for -c (select encoder/decoder)", "codec",
         .u1.names_alt = alt_codec, },
     { "pre",                    OPT_TYPE_STRING, OPT_PERSTREAM | OPT_OUTPUT | OPT_EXPERT | OPT_HAS_ALT,
         { .off       = OFFSET(presets) },
@@ -1517,17 +1517,18 @@ const OptionDef options[] = {
         "set chapters mapping", "input_file_index" },
     { "t",                      OPT_TYPE_TIME, OPT_OFFSET | OPT_INPUT | OPT_OUTPUT,
         { .off = OFFSET(recording_time) },
-        "record or transcode \"duration\" seconds of audio/video",
+        "stop transcoding after specified duration",
         "duration" },
     { "to",                     OPT_TYPE_TIME, OPT_OFFSET | OPT_INPUT | OPT_OUTPUT,
         { .off = OFFSET(stop_time) },
-        "record or transcode stop time", "time_stop" },
+        "stop transcoding after specified time is reached",
+        "time_stop" },
     { "fs",                     OPT_TYPE_INT64, OPT_OFFSET | OPT_OUTPUT | OPT_EXPERT,
         { .off = OFFSET(limit_filesize) },
         "set the limit file size in bytes", "limit_size" },
     { "ss",                     OPT_TYPE_TIME, OPT_OFFSET | OPT_INPUT | OPT_OUTPUT,
         { .off = OFFSET(start_time) },
-        "set the start time offset", "time_off" },
+        "start transcoding at specified time", "time_off" },
     { "sseof",                  OPT_TYPE_TIME, OPT_OFFSET | OPT_INPUT | OPT_EXPERT,
         { .off = OFFSET(start_time_eof) },
         "set the start time offset relative to EOF", "time_off" },
@@ -1551,7 +1552,7 @@ const OptionDef options[] = {
         "set the recording timestamp ('now' to set the current time)", "time" },
     { "metadata",               OPT_TYPE_STRING, OPT_SPEC | OPT_OUTPUT,
         { .off = OFFSET(metadata) },
-        "add metadata", "string=string" },
+        "add metadata", "key=value" },
     { "program",                OPT_TYPE_STRING, OPT_SPEC | OPT_EXPERT | OPT_OUTPUT,
         { .off = OFFSET(program) },
         "add program with specified streams", "title=string:st=number..." },
@@ -1659,7 +1660,7 @@ const OptionDef options[] = {
         "set profile", "profile" },
     { "filter",                 OPT_TYPE_STRING, OPT_PERSTREAM | OPT_OUTPUT | OPT_HAS_ALT,
         { .off = OFFSET(filters) },
-        "set stream filtergraph", "filter_graph",
+        "apply specified filters to audio/video", "filter_graph",
         .u1.names_alt = alt_filter, },
     { "filter_threads",         OPT_TYPE_FUNC, OPT_FUNC_ARG | OPT_EXPERT,
         { .func_arg = opt_filter_threads },
@@ -1751,7 +1752,7 @@ const OptionDef options[] = {
         .u1.name_canon = "frames", },
     { "r",                          OPT_TYPE_STRING, OPT_VIDEO | OPT_PERSTREAM | OPT_INPUT | OPT_OUTPUT,
         { .off = OFFSET(frame_rates) },
-        "set frame rate (Hz value, fraction or abbreviation)", "rate" },
+        "override input framerate/convert to given output framerate (Hz value, fraction or abbreviation)", "rate" },
     { "fpsmax",                     OPT_TYPE_STRING, OPT_VIDEO | OPT_PERSTREAM | OPT_OUTPUT | OPT_EXPERT,
         { .off = OFFSET(max_frame_rates) },
         "set max frame rate (Hz value, fraction or abbreviation)", "rate" },
@@ -1784,7 +1785,7 @@ const OptionDef options[] = {
         "rate control override for specific intervals", "override" },
     { "vcodec",                     OPT_TYPE_FUNC,   OPT_VIDEO | OPT_FUNC_ARG | OPT_PERFILE | OPT_INPUT | OPT_OUTPUT | OPT_HAS_CANON,
         { .func_arg = opt_video_codec },
-        "force video codec ('copy' to copy stream)", "codec",
+        "alias for -c:v (select encoder/decoder for video streams)", "codec",
         .u1.name_canon = "codec", },
     { "timecode",                   OPT_TYPE_FUNC,   OPT_VIDEO | OPT_FUNC_ARG | OPT_PERFILE | OPT_OUTPUT | OPT_EXPERT,
         { .func_arg = opt_timecode },
@@ -1806,7 +1807,7 @@ const OptionDef options[] = {
         "Version of the vstats format to use."},
     { "vf",                         OPT_TYPE_FUNC,   OPT_VIDEO | OPT_FUNC_ARG | OPT_PERFILE | OPT_OUTPUT | OPT_HAS_CANON,
         { .func_arg = opt_video_filters },
-        "set video filters", "filter_graph",
+        "alias for -filter:v (apply filters to video streams)", "filter_graph",
         .u1.name_canon = "filter", },
     { "intra_matrix",               OPT_TYPE_STRING, OPT_VIDEO | OPT_EXPERT | OPT_PERSTREAM | OPT_OUTPUT,
         { .off = OFFSET(intra_matrices) },
@@ -1879,11 +1880,11 @@ const OptionDef options[] = {
         "disable audio" },
     { "acodec",           OPT_TYPE_FUNC,    OPT_AUDIO | OPT_FUNC_ARG  | OPT_PERFILE | OPT_INPUT | OPT_OUTPUT | OPT_HAS_CANON,
         { .func_arg = opt_audio_codec },
-        "force audio codec ('copy' to copy stream)", "codec",
+        "alias for -c:a (select encoder/decoder for audio streams)", "codec",
         .u1.name_canon = "codec", },
     { "ab",               OPT_TYPE_FUNC,    OPT_AUDIO | OPT_FUNC_ARG | OPT_PERFILE | OPT_OUTPUT,
         { .func_arg = opt_bitrate },
-        "audio bitrate (please use -b:a)", "bitrate" },
+        "alias for -b:a (select bitrate for audio streams)", "bitrate" },
     { "atag",             OPT_TYPE_FUNC,    OPT_AUDIO | OPT_FUNC_ARG  | OPT_EXPERT | OPT_PERFILE | OPT_OUTPUT | OPT_HAS_CANON,
         { .func_arg = opt_old2new },
         "force audio tag/fourcc", "fourcc/tag",
@@ -1901,7 +1902,7 @@ const OptionDef options[] = {
         .u1.name_canon = "channel_layout", },
     { "af",               OPT_TYPE_FUNC,    OPT_AUDIO | OPT_FUNC_ARG  | OPT_PERFILE | OPT_OUTPUT | OPT_HAS_CANON,
         { .func_arg = opt_audio_filters },
-        "set audio filters", "filter_graph",
+        "alias for -filter:a (apply filters to audio streams)", "filter_graph",
         .u1.name_canon = "filter", },
     { "guess_layout_max", OPT_TYPE_INT,     OPT_AUDIO | OPT_PERSTREAM | OPT_EXPERT | OPT_INPUT,
         { .off = OFFSET(guess_layout_max) },
@@ -1913,7 +1914,7 @@ const OptionDef options[] = {
         "disable subtitle" },
     { "scodec", OPT_TYPE_FUNC, OPT_SUBTITLE | OPT_FUNC_ARG  | OPT_PERFILE | OPT_INPUT | OPT_OUTPUT | OPT_HAS_CANON,
         { .func_arg = opt_subtitle_codec },
-        "force subtitle codec ('copy' to copy stream)", "codec",
+        "alias for -c:s (select encoder/decoder for subtitle streams)", "codec",
         .u1.name_canon = "codec", },
     { "stag",   OPT_TYPE_FUNC, OPT_SUBTITLE | OPT_FUNC_ARG  | OPT_EXPERT  | OPT_PERFILE | OPT_OUTPUT | OPT_HAS_CANON,
         { .func_arg = opt_old2new }
@@ -1978,7 +1979,7 @@ const OptionDef options[] = {
     /* data codec support */
     { "dcodec", OPT_TYPE_FUNC, OPT_FUNC_ARG | OPT_DATA | OPT_PERFILE | OPT_EXPERT | OPT_INPUT | OPT_OUTPUT | OPT_HAS_CANON,
         { .func_arg = opt_data_codec },
-        "force data codec ('copy' to copy stream)", "codec",
+        "alias for -c:d (select encoder/decoder for data streams)", "codec",
         .u1.name_canon = "codec", },
     { "dn", OPT_TYPE_BOOL, OPT_DATA | OPT_OFFSET | OPT_INPUT | OPT_OUTPUT,
         { .off = OFFSET(data_disable) }, "disable data" },